/*
Nombre:   gxlselect.c
Sintaxis: gxl <Puerto a conctar en el servidorX>
*/
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <signal.h>

#define XPORTNUMBER 6000
#define MAXHOSTNAME 80

void reusePort(int sock);


int main(int argc,char *argv[])
{
    //definicion de las variables
    char buf[1024];
    int s, n, ns, len,length,fromlen,rc,sd,i;
    int sockList, lastSock=0;
    char ThisHost[MAXHOSTNAME];
    char direc[MAXHOSTNAME];

    struct hostent *hp,*hpp,*hl,*gethostbyname();
    struct servent *sp;
    struct sockaddr_in local;
    struct sockaddr_in remote;
    struct sockaddr_in server;
    fd_set readfds, readfdsCopy;

    if (argc!=2)
     {
     printf("Use: gxl <Puerto> \n");
     exit (2);
     }
   strcpy(direc,argv[1]);
   if ((atoi(argv[1])<=1024))
      {
      printf("error al ingresar el numero del puerto ");
      exit(1);
      }
  sp = getservbyname("echo", "tcp");

  //Obtiene los datos del gateway
  gethostname(ThisHost, MAXHOSTNAME);
  printf("*****************************************\n");
  printf("---- Gateway corriendo en : %s \n", ThisHost);

  if  ( (hp = gethostbyname(ThisHost)) == NULL )
     {
     fprintf(stderr, "No se puede encontrar el host %s\n", ThisHost);
     exit(-1);
     }
  bcopy ( hp->h_addr, &(local.sin_addr), hp->h_length);
  printf("    (Direccion ip del Gateway : %s )\n", inet_ntoa(local.sin_addr));

  //crea las direcciones en el gateway
  local.sin_family = AF_INET;
  local.sin_port = htons(atoi(argv[1]));
  local.sin_addr.s_addr = htonl(INADDR_ANY); /* Use the wildcard address.*/

  //crea el socket.
  s = socket(hp->h_addrtype,SOCK_STREAM, 0);

  reusePort(s);

  if ( bind( s, (struct sockaddr *) &local, sizeof(local) ) )
     {
     close(s);
     perror("binding name to stream socket");
     exit(-1);
     }

  length = sizeof(local);
  if ( getsockname (s, (struct sockaddr *) &local,&length) )
    {
    perror("getting socket name");
    exit(0);
    }

  printf("    (Gateway Port es: %d)\n", ntohs(local.sin_port));

  len = sizeof(struct sockaddr_in);

  // Obtiene los datos del servidor X

  if ((hpp = gethostbyname(ThisHost)) == NULL )
    {
    server.sin_addr.s_addr = inet_addr(ThisHost);
    if ((hpp = gethostbyaddr((void *)&server.sin_addr.s_addr,sizeof(server.sin_addr.s_addr),AF_INET)) == NULL)
      {
      fprintf(stderr, "Can't find host %s\n",ThisHost);
      exit(-1);
      }
    }
  printf("---- El Servidor X es: %s\n", hpp->h_name);
  bcopy ( hpp->h_addr, &(server.sin_addr), hpp->h_length);
  printf("    (Su direcion ip es: %s )\n", inet_ntoa(server.sin_addr));

  //Consruyendo el socket para enviar al servidorX
  server.sin_family = hpp->h_addrtype;
  server.sin_port = htons(XPORTNUMBER);

  //   Crea un soket para enviar y recibir
  sd = socket (hpp->h_addrtype,SOCK_STREAM,0);

  // Esperando por conecciones.
  listen(s, 5);
  printf("****************************************\n");
  printf("****** Esperando por una conexion ******\n");
  printf("****************************************\n");
  // aqui empieza select
  fromlen = sizeof(remote);
  FD_ZERO(&readfdsCopy);
  FD_SET(s,&readfdsCopy);

  for(;;)
    {
    memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
    n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);
    if (n > 0)
      {
      if (FD_ISSET(s, &readfds))
        {
	printf("    Se ha aceptado una conexion...\n");
	ns = accept(s, (struct sockaddr *)&remote, &fromlen);
	// Connect al X server
	connect(sd, (struct sockaddr *)&server, sizeof(server));
	//datos maquina remota
	printf("    La Maquina Remota y su pueto son:%s:%d\n", inet_ntoa(remote.sin_addr),ntohs(remote.sin_port));

	if ((hl = gethostbyaddr((char*)&remote.sin_addr.s_addr,sizeof(remote.sin_addr.s_addr),AF_INET)) == NULL)
	    fprintf(stderr, "Can't find host %s\n", inet_ntoa(remote.sin_addr));
	else
	    printf("    (Su nombre es : %s)\n", hl->h_name);

	FD_SET(ns, &readfdsCopy);
	FD_SET(sd, &readfdsCopy);
        }

	if (FD_ISSET(ns, &readfds))
             EchoServe(ns,sd);

	if (FD_ISSET(sd, &readfds))
             EchoServe(sd,ns);
      }
    }

    close(s);
    close (ns);
    close (sd);
    exit(0);

}

EchoServe(ns,sd)
int ns;
int sd;
{
  char buf[1024];
  int rc,i;

  //Obtiene los datos de la maquina remota y la envia al servidor X

    if( (rc=read(ns, buf, sizeof(buf))) < 0)
      perror("al recivir un stream  message");
    if (rc > 0)
      {

      if (send(sd, buf, rc, 0) <0 )
        perror("al mandrar un stream message");
      //limpieza del buffer
      for(i=0; i<1024; i++) buf[i]='\0';
      }
    else
      {
      printf("    Saliendo........\n");
      printf("****************************************\n");
      close (ns);
      close (sd);
      exit(0);
      }

}


void reusePort(int s)
{
  int one=1;
  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error en setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}
