/*
Nombre:   gxrfork.c
Sintaxis: gxrfork <Nombre host>
*/
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <signal.h>

#define PORTNUMBER  6002
#define XPORTNUMBER 6000
#define MAXHOSTNAME 80
int ns,sd,s;
void reusePort(int sock);
void getsignal(int j)
{
      close (ns);
      close (sd);
      exit(0);
}
int main(int argc,char *argv[])
{
    //definicion de las variables
    char buf[1024];
    int s, n, len,length,fromlen,rc,i,count;
pid_t hijo[12];
    int sockList, lastSock=0;
    char ThisHost[MAXHOSTNAME];
    char direc[MAXHOSTNAME];

    struct hostent *hp,*hpp,*hl,*gethostbyname();
    struct servent *sp;
    struct sockaddr_in local;
    struct sockaddr_in remote;
    struct sockaddr_in server;
    fd_set readfds, readfdsCopy;

    if (argc!=2)
     {
     printf("Use: gxr <Nombre-ServidorX> \n");
     exit (2);
     }
   strcpy(direc,argv[1]);

  sp = getservbyname("echo", "tcp");

  //Obtiene los datos del gateway
  gethostname(ThisHost, MAXHOSTNAME);
  printf("*****************************************\n");
  printf("---- Gateway corriendo en : %s \n", ThisHost);

  if  ( (hp = gethostbyname(ThisHost)) == NULL )
     {
     fprintf(stderr, "No se puede encontrar el host %s\n", ThisHost);
     exit(-1);
     }
  bcopy ( hp->h_addr, &(local.sin_addr), hp->h_length);
  printf("    (Direccion ip del Gateway : %s )\n", inet_ntoa(local.sin_addr));

  //crea las direcciones en el gateway
  local.sin_family = AF_INET;
  local.sin_port = htons(PORTNUMBER);
  local.sin_addr.s_addr = htonl(INADDR_ANY); /* Use the wildcard address.*/

  //crea el socket.
  s = socket(hp->h_addrtype,SOCK_STREAM, 0);

  reusePort(s);

  if ( bind( s, (struct sockaddr *) &local, sizeof(local) ) )
     {
     close(s);
     perror("binding name to stream socket");
     exit(-1);
     }

  length = sizeof(local);
  if ( getsockname (s, (struct sockaddr *) &local,&length) )
    {
    perror("getting socket name");
    exit(0);
    }

  printf("    (Gateway Port es: %d)\n", ntohs(local.sin_port));

  len = sizeof(struct sockaddr_in);

  // Obtiene los datos del servidor X

  if ((hpp = gethostbyname(direc)) == NULL )
    {
    server.sin_addr.s_addr = inet_addr(direc);
    if ((hpp = gethostbyaddr((void *)&server.sin_addr.s_addr,sizeof(server.sin_addr.s_addr),AF_INET)) == NULL)
      {
      fprintf(stderr, "Can't find host %s\n", direc);
      exit(-1);
      }
    }
  printf("---- El Servidor X es: %s\n", hpp->h_name);
  bcopy ( hpp->h_addr, &(server.sin_addr), hpp->h_length);
  printf("    (Su direcion ip es: %s )\n", inet_ntoa(server.sin_addr));

  //Consruyendo el socket para enviar al servidorX
  server.sin_family = hpp->h_addrtype;
  server.sin_port = htons(XPORTNUMBER);

  //   Crea un soket para enviar y recibir
  sd = socket (hpp->h_addrtype,SOCK_STREAM,0);

  // Esperando por conecciones.
  listen(s, 5);
  printf("****************************************\n");
  printf("****** Esperando por una conexion ******\n");
  printf("****************************************\n");

  fromlen = sizeof(remote);

    count=0;

    {
    //accept
    ns  = accept(s, (struct sockaddr *) &remote, &fromlen);
    // Connect al X server
    connect(sd, (struct sockaddr *)&server, sizeof(server));

    printf("    Se ha aceptado una conexion...\n");
    //datos maquina remota
    printf("    La Maquina Remota y su pueto son: %s:%d\n", inet_ntoa(remote.sin_addr),ntohs(remote.sin_port));

    if ((hl = gethostbyaddr((char*)&remote.sin_addr.s_addr,sizeof(remote.sin_addr.s_addr),AF_INET)) == NULL)
       fprintf(stderr, "Can't find host %s\n", inet_ntoa(remote.sin_addr));
    else
       printf("    (Su nombre es : %s)\n", hl->h_name);

    if ( (hijo[count]=fork()) == 0)
       EchoServe(ns,sd,s);

    count++;

    }
    //espera a que finalicen los hijos

    for (i=0;i<count;i++)
	{
	waitpid(hijo[i],NULL,0);
	}
    close(s);
    close (ns);
    close (sd);
    printf("    Saliendo........\n");
    printf("****************************************\n");
    exit(0);

}

EchoServe(ns,sd,s)
{
  char buf[1024];
  char buf2[1024];
  int rc,i;
  pid_t hijox;
  struct  hostent *hp,*hpp,*gethostbyname();
  struct sockaddr_in server;

  if ( (hijox=fork()) == 0)
     {
      EchoServe2(ns,sd);
     }

  //Obtiene los datos de la maquina remota y la envia al servidor X
  for(;;)
    {
    if( (rc=read(ns, buf, sizeof(buf))) < 0)
      perror("al recivir un stream  message");
    if (rc > 0)
      {
      if (send(sd, buf, rc, 0) <0 )
        perror("al mandrar un stream message");
     for(i=0; i<1024; i++) buf[i]='\0';
      }
   else
      {
      kill(hijox,SIGINT);
      waitpid(hijox,NULL,0);
      close(s);
      close (ns);
      close (sd);
      exit(0);
      }
    }
}

EchoServe2(ns,sd)
{

  char buf2[1024];
  int rc,i;
signal(SIGINT,getsignal);//(ns,sd));
for(;;)
{
      //lee datos del servidor X y los envia de vuelta a la maquina remota
      rc=read(sd, buf2, sizeof(buf2));
      if (rc > 0)
      {
      send(ns, buf2, rc, 0);
      for(i=0; i<1024; i++) buf2[i]='\0';
       }

 else
      {
      exit(0);
      }
    }
}

void reusePort(int ss)
{
  int one=1;
  if ( setsockopt(ss,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
    {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
    }
}
